[![PyPI version](https://badge.fury.io/py/meliora.svg)](https://badge.fury.io/py/vangap-meliora) ![CI Build](https://github.com/at621/meliora/actions/workflows/CI.yml/badge.svg?event=push)

About the package
------------------

**meliora** is a Python package that provides a set of statistical tests and tools to assess the performance of the credit risk models. All tests are covered with unit tests and algorithms have been replicated in other tools like R, MATLAB and SAS to avoid errors. Whenever possible, the definition of the test was retrieved from the authoritive source like the EBA, the ECB or the Basel Committee.

The main contributors started building their first statistical credit models back in 2003. Over the years, we have impemented similar set of tests in several different financial institutions. 

This package is standing on the shoulders of giants as it makes heavy use of the Python
ecosystem and especially Scikit-learn, Scipy and Statsmodels. Several functions are straightforward
wrappers using these resources and are provided to the user for convenience purposes. The authors
have taken great care to ensure that no part of this package contains proprietary code. 

Main aim
-----------------
The aim of the package is to provide all common tests used by today's modellers when developing, maintaining and validating their PD, LGD, EAD and prepayment models. The aim of this package is to provide credit risk practioners with the tools to develop their credit risk models without reinventing the wheel. 

Main Features
-----------------
  - tests cover both IFRS 9 and IRB models as well as non-regulatory models
  - the tool contains more than 30 tests
  - all test have been covered with unit tests 
  - the tests have been documented in detail
  - commonly accepted tresholds have been provided for convenience purposes

  For the list of all tests, see Overview > List of tests

Tests that are currently included in the package
--------------------------------------------------

| #  | Name                                               | Area             | Estimate |
|----|----------------------------------------------------|------------------|----------|
| 1  | Binomial test                                      | Calibration      | PD       |
| 2  | Chi-Square test (Hoshmer-Lemeshow test)            | Calibration      | PD       |
| 3  | Normal test                                        | Calibration      | PD       |
| 4  | Spiegehalter test                                  | Calibration      | PD       |
| 5  | Redelmeier test                                    | Calibration      | PD       |
| 6  | Herfhindahl index / Concentration of rating grades | Concentration    | PD       |
| 7  | Brier score                                        | Discrimination   | PD       |
| 8  | Receiver Operating Characteristic                  | Discrimination   | PD       |
| 9 | Accuracy Ratio                                     | Discrimination   | PD       |
| 10 | Kendall’s τ                                        | Discrimination   | PD       |
| 11 | Somers’ D                                          | Discrimination   | PD       |
| 12 | Conditional Information Entropy Ratio              | Discrimination   | PD       |
| 13 | Kullback-Leibler distance                          | Discrimination   | PD       |
| 14 | Information value                                  | Discrimination   | PD       |
| 15 | Bayesian error rate                                | Discrimination   | PD       |
| 16 | Cumulative LGD accuracy ratio                      | Discrimination   | LGD      |
| 17 | Loss Capture Ratio                                 | Discrimination   | LGD      |
| 18 | Kolmogorov-Smirnov test                            | Discrimination   | PD       |
| 19 | Spearman’s rank correlation                        | Discrimination   | LGD      |
| 20 | Jeffrey's test                                     | Discrimination   | PD       |
| 21 | ELBE back-test using a t-test                      | Discrimination   | LGD      |
| 22 | Migration matrices test                            | Discrimination   | PD       |
| 23 | Loss Shortfall                                     | Predictive power | LGD      |
| 24 | Mean Absolute Deviation                            | Predictive power | LGD      |
| 25 | Population Stability Index                         | Stability        | PD       |
| 26 | Stability of transition matrices                   | Stability        | PD       |

Full list of dependencies
---------------------------
- NumPy (https://www.numpy.org)
- Pandas (https://pandas.pydata.org/)
- Statsmodels (https://www.statsmodels.org/)
- Scikit-learn (https://scikit-learn.org/)
- Scipy (https://scipy.org/)


Getting Help
------------------

For usage questions, send an email to anton.treialt@aistat.com

License
----------------------
MIT License

#' @title Variance of the volume under the ROC surface
#' @description Computes the volume under the ROC surface (VUS) and its variance for a vector of realisations \code{y} (i.e. realised categories) and a vector of predictions \code{fx} (i.e. values of the a ranking function f) for the purpose of assessing the discrimiatory power in a multi-class classification problem.
#' @param y a vector of realized categories.
#' @param fx a vector of predicted values of the ranking function f.
#' @param ncores number of cores to be used for parallelized computations. The default value is 1.
#' @param clusterType type of cluster to be initialized in case more than one core is used for calculations. The default values is "SOCK". For details regarding the different types to be used, see \code{\link[parallel]{makeCluster}}.
#' @return The implemented algorithm is based on Waegeman, De Baets and Boullart (2008). A list of length two is returned, containing the following components:
#' \item{var}{variance of the volume under the ROC surface}
#' \item{val}{volume under the ROC surface}
#' @examples VUSvar(rep(1:5,each=3),c(1,2,3,rep(2:5,each=3)))
#' @references Waegeman W., De Baets B., Boullart L., 2008. On the scalability of ordered multi-class ROC analysis. Computational Statistics & Data Analysis 52, 3371-3388.

 
VUSvar <- function(y,fx,ncores = 1, clusterType="SOCK") {

  if (any(is.na(fx)) | any(is.na(y))) {
    stop("\n no NA values allowed for neither 'fx' nor 'y'")
  }
  
  if(length(y)!=length(fx)){
  	stop("\n 'fx' and 'x' need to have the same dimension.")
  }

	n <- length(y)
	dat <- cbind(y,fx)
	dat <- dat[order(y,decreasing=TRUE), ]
	dat <- dat[order(dat[,2]), ]
	u <- sort(unique(y))
	r <- length(u)


	dat <- cbind(dat,rep(NA,n),seq(1,n))
	psi   <- rep(0,r)
	out <- rep(0,n)
	count<-rep(0,r)

	for (i in 1:n) {

	  cat <- which(dat[i,1] == u)
		dat[i,3] <- cat
		if (cat == 1) {
		  psi[1] <- psi[1]+1
		} else {
		  psi[cat] <- psi[cat]+psi[cat-1]
		}
		out[i] <- count[cat]
		count[cat] <- count[cat] + 1
	}
  vurocs=list(val=psi[r]/prod(count),count=count)
  
	part <- matrix(0, nrow=2^r, ncol=r)
	for (i in 1:r) {
		part[,i] <- kronecker((0:(2^(r-i+1)-1))%%2,matrix(1,nrow=2^(i-1),ncol=1))
	}

	dat <- rbind(c(min(y)-1,min(fx)-1,0,0),dat,c(max(y)+1,max(fx)+1,r+1,n+1))
	u <- c(min(y)-1,u,max(y)+1)
	uu <- 0:(r+1)
	part <- cbind(rep(1,2^r),part,rep(1,2^r))
	out <- c(0,out,0)

	foreachPartition <- function(s,vurocs,out,uu,dat,part,n,r) {

  	Z11 <- uu[as.logical(part[s,])]
  	p <- 1
  	V <- list(0)
  
  	for (k in 1:(r+2)) {
  	  if (sum(uu[k] == Z11) > 0) {
  	    V[[p]] <- dat[dat[,3]==uu[k], ,drop=FALSE]
  	    p <- p+1
  	  }
  	}
  	len <- rep(0,length(Z11)-1)
  
  	for (k in 1:(length(Z11)-1)) {
  	  len[k] <- nrow(V[[k]])*nrow(V[[k+1]])
  	}
  	len <- c(0,cumsum(len))
  	weight <- rep(0,len[length(Z11)])
  
  	for (p in 1:(length(Z11)-1)) {
  	  K <- Z11[p]
  	  L <- Z11[p+1]
  	  if (L==(K+1)) {
  	    for (a in 1:nrow(V[[p]])) {
  	      for (b in 1:nrow(V[[p+1]])) {
  	        if (V[[p]][a,2]<V[[p+1]][b,2]) {
  	          weight[b+(a-1)*nrow(V[[p+1]])+len[p]] <- 1
  	        }
  	      }
  	    }
  	  } else {
  	    int <- 0
  	    for (i in V[[p]][,4]) {
  	      w <- rep(0,L-K-1)
  	      for (j in (i+1):(n+1)) {
  	        m <- dat[j+1,3]
  	        if (m == (K+1)) {
  	          w[1] <- w[1]+1
  	        }
  	        if ((K+1)<m & m<L) {
  	          w[m-K] <- w[m-K] + w[m-K-1]
  	        }
  	        if (m == L) {
  	          weight[len[p] + int*nrow(V[[p+1]]) + out[j+1] +1] <- w[L-K-1]
  	        }
  	      }
  	      int <- int + 1
  	    }
  	  }
  	}
  	gamma <- rep(0,n+2)
  	gamma[1] <- 1
  
  	for (k in 1:(length(Z11)-1)) {
  	  out1 <- 0
  	  for (a in V[[k]][,4]) {
  	    out1 <- out1 + 1
  	    out2 <- 0
  	    for (b in V[[k+1]][,4]) {
  	      out2 <- out2 + 1
  	      gamma[b+1] <- gamma[b+1] + gamma[a+1]*weight[out2+(out1-1)*nrow(V[[k+1]])+len[k]]^2
  	    }
  	  }
  	}
  	GammaRes <- gamma[n+2]
  	Z2 <- uu[!as.logical(part[s,])]
  	n.under <- prod(vurocs[[2]][Z2])*prod(vurocs[[2]])
  	prod(vurocs[[2]][Z2]-1)*(GammaRes/n.under-vurocs[[1]]^2)
	}


	if (ncores==1) {
	  sigma2 <- sapply(1:2^r,foreachPartition,vurocs,out,uu,dat,part,n,r)
	} else {
  	cl <- makeCluster(min(ncores,detectCores()), type=clusterType )
  	registerDoParallel(cl)
  	sigma2<-foreach(i=1:2^r,.combine = c) %dopar% foreachPartition(i,vurocs,out,uu,dat,part,n,r)
  	on.exit(stopCluster(cl))
	}

	sigma2 <- sum(sigma2)/prod(vurocs[[2]])
	
	return(list(var=sigma2,val=vurocs[[1]]))
}

test_data <- read.csv("pd_test_data.csv")


###############################################

# to install iterativeBMA package:
#if (!requireNamespace("BiocManager", quietly = TRUE))
#  install.packages("BiocManager")
#BiocManager::install("iterativeBMA")

library(iterativeBMA)

brier.score(test_data$predicted_pd, test_data$default_flag)/nrow(test_data)

# Agrees with Meliora (other than defining Brier score as sum rather than avg)

############

#install.packages("PDtoolkit")

library(PDtoolkit)

test_agg <- read.csv("pd_test_agg.csv")
pp.testing(rating.label = test_agg$ratings,
           pdc = test_agg$PD,
           no = test_agg$N,
           nb = test_agg$D, 
           alpha = 0.05)

# Jeffrey's and Binomial both agree with Meliora.
# Hosmer-Lemeshow differs only because the author computes a chi-squared cdf with
# k degrees of freedom rather than k-2 which is what our source says to use.
# (See hl.test at https://github.com/andrija-djurovic/PDtoolkit/blob/main/R/12_PREDICTIVE_POWER.R)

##########

# install.packages("remotes")
# remotes::install_github("ayhandis/creditR")

library(creditR)

df <- master.scale(test_data, "default_flag", "predicted_pd")
h <- Herfindahl.Hirschman.Index(df, "Total.Observations")
h

# Herfindahl index agrees, but I was unable to find any available Herfindahl TEST to compare with

##########

# There doesn't appear to be an R implementation of the Spiegelhalter test.
# The SAS implementation seems to be very limited in its scope: it doesn't let you
# specify the hypothesized success probabilities as far as I can tell.

#' @title Kruskal's Gamma and its asymptotic standard errors
#' @description Computes Kruskal's Gamma on a given cartesian product Y x f(X), where Y consists of the components of \code{y} and f(X) consists of the components of \code{fx}. Furthermore, the asymptotic standard error as well as the modified asymptotic standard error to test the null hypothesis that the measure is zero are provided as defined in Brown and Benedetti (1977).
#' @param y a vector of realized categories.
#' @param fx a vector of predicted values of the ranking function f.
#' @return A list of length three is returned, containing the following components:
#' \item{val}{Kruskal's Gamma}
#' \item{ASE}{the asymptotic standard error of Kruskal's Gamma}
#' \item{ASE0}{the modified asymptotic error of Kruskal's Gamma under the null hypothesis}
#' @examples Kruskal_Gamma(rep(1:5,each=3),c(3,3,3,rep(2:5,each=3)))
#' @references Brown, M.B., Benedetti, J.K., 1977. Sampling Behavior of Tests for Correlation in Two-Way Contingency Tables. Journal of the American Statistical Association 72(358), 309-315

Kruskal_Gamma <- function(y,fx){

  if (any(is.na(fx)) | any(is.na(y))) {
    stop("\n both 'fx' and 'y' must not contain NA values")
  }
  
  if (length(fx)!=length(y)) {
    stop("\n both 'fx' and 'y' must be of the same length")
  }

  CT  <- table(y,fx)
  b  <- ncol(CT)
  a  <- nrow(CT)
  W <- length(y)

  C1 <- D1 <- matrix(0,ncol=b,nrow=a)
  if(a>2 && b>2){
    C1 <- funC(CT)
    D1 <- funD(CT)
  }

  C2 <- D2 <- matrix(0,ncol=b,nrow=a)
  if (b>2) {
    C2 <- funC1(CT)
    D2 <- funD1(CT)
  }

  C3 <- D3 <- matrix(0,ncol=b,nrow=a)
  if (a>2) {
    C3 <- funC2(CT)
    D3 <- funD2(CT)
  }
  C <- C1 + C2 + C3
  D <- D1 + D2 + D3

  C[1,1] <- sum(CT[2:a,2:b])
  C[a,b] <- sum(CT[1:(a-1),1:(b-1)])
  C[a,1] <- C[1,b] <- 0

  D[1,b] <- sum(CT[2:a,1:(b-1)])
  D[a,1] <- sum(CT[1:(a-1),2:b])
  D[1,1] <- D[a,b] <- 0

  P  <- sum(CT*C)
  Q  <- sum(CT*D)

  Kruskal_Gamma <- list()
  Kruskal_Gamma$val  <- (P-Q)/(P+Q)
  Kruskal_Gamma$ASE0 <- 2/(P+Q)*sqrt(sum(CT*(C-D)^2)-(P-Q)^2/W)
  Kruskal_Gamma$ASE  <- 4/(P+Q)^2*sqrt(sum(CT*(Q*C-P*D)^2))

  return(Kruskal_Gamma)
}

#' @title Volume under the ROC surface
#' @description This function computes the volume under the ROC surface (VUS) for a vector of realisations \code{y} (i.e. realised categories) and a vector of predictions \code{fx} (i.e. values of the a ranking function f) for the purpose of assessing the discrimiatory power in a multi-class classification problem. This is achieved by counting the number of r-tuples that are correctly ranked by the ranking function f. Thereby, r is the number of classes of the response variable \code{y}.
#' @param y a vector of realized categories.
#' @param fx a vector of predicted values of the ranking function f.
#' @return The implemented algorithm is based on Waegeman, De Baets and Boullart (2008). A list of length two is returned, containing the following components:
#' \item{val}{volume under the ROC surface} 
#' \item{count}{counts the number of observations falling into each category}
#' @examples VUS(rep(1:5,each=3),c(3,3,3,rep(2:5,each=3)))
#' @references Waegeman W., De Baets B., Boullart L., 2008. On the scalability of ordered multi-class ROC analysis. Computational Statistics & Data Analysis 52, 3371-3388.

VUS <- function(y,fx){

  if (any(is.na(fx)) | any(is.na(y))) {
    stop("\n no NA values allowed for neither 'fx' nor 'y'")
  }
  
  if (length(fx)!=length(y)) {
   stop("\n 'y' and 'fx' need to have the same length.")
  }


  n     <- length(y)
  u     <- sort(unique(y))
  r     <- length(u)
  dat   <- cbind(y,fx)
  dat <- dat[order(y,decreasing=TRUE), ]
  dat <- dat[order(dat[,2]), ]
  psi   <- rep(0,r)
  count <- rep(0,r)

  for (i in 1:length(y)) {
    cat <- which(dat[i,1]==u)
    if (cat == 1) {
      psi[1] <- psi[1]+1
    } else {
      psi[cat] <- psi[cat]+psi[cat-1]
    }
    count[cat] <- count[cat] + 1
  }

  return(list(val=psi[r]/prod(count), count= count))
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
#' @title
#' Calculate the p-value of the null hypothesis that two outcomes are from the
#' same dataset
#'
#' @description
#' Specify an outcome variable and return p-test outputs.
#' All numeric variables in the dataset are used as predictor variables.
#'
#' @author Mark Powers <mark.powers@@microsoft.com>
#'
#' @param data A Person Query dataset in the form of a data frame.
#' @param outcome A string specifying the name of a binary variable, i.e. can
#'   only contain the values 1 or 0. Used to group the two distributions.
#' @param behavior A character vector specifying the column to be used as the
#'   behavior to test.
#' @param paired Specify whether the dataset is paired or not. Defaults to
#' `TRUE`.
#'
#' @return
#' Returns a numeric value representing the p-value outcome of the test.
#'
#' @family Support
#'
#' @import dplyr
#'
#' @details
#' This function is a wrapper around `wilcox.test()` from 'stats'.
#'
#' @examples
#' # Simulate a binary variable X
#' # Returns a single p-value
#' library(dplyr)
#' sq_data %>%
#'   mutate(X = ifelse(Email_hours > 6, 1, 0)) %>%
#'   p_test(outcome = "X", behavior = "External_network_size")
#'
#' @export
p_test <- function(data,
                   outcome,
                   behavior,
                   paired = FALSE){

  train <- data %>%
    dplyr::filter(!!sym(outcome) == 1 | !!sym(outcome) == 0) %>%
    select(!!sym(outcome), !!sym(behavior)) %>%
    mutate(outcome = as.character(!!sym(outcome))) %>%
    mutate(outcome = as.factor(!!sym(outcome)))

  pos <- train %>% dplyr::filter(outcome == 1, na.rm=TRUE) %>% select(behavior)
  neg <- train %>% dplyr::filter(outcome == 0, na.rm=TRUE) %>% select(behavior)

  s <- stats::wilcox.test(unlist(pos), unlist(neg), paired = paired)

  return(s$p.value)
}

#' @title Kendall's Tau_c and its asymptotic standard errors
#' @description Computes Kendall's Tau_c on a given cartesian product Y x f(X), where Y consists of the components of \code{y} and f(X) consists of the components of \code{fx}. Furthermore, the asymptotic standard error as well as the modified asymptotic standard error to test the null hypothesis that the measure is zero are provided as defined in Brown and Benedetti (1977).
#' @param y a vector of realized categories.
#' @param fx a vector of predicted values of the ranking function f.
#' @return A list of length three is returned, containing the following components:
#' \item{val}{Kendall's Tau_c}
#' \item{ASE}{the asymptotic standard error of Kendall's Tau_c}
#' \item{ASE0}{the modified asymptotic error of Kendall's Tau_c under the null hypothesis}
#' @examples Kendall_tauc(rep(1:5,each=3),c(3,3,3,rep(2:5,each=3)))
#' @references Brown, M.B., Benedetti, J.K., 1977. Sampling Behavior of Tests for Correlation in Two-Way Contingency Tables. Journal of the American Statistical Association 72(358), 309-315

Kendall_tauc <- function(y,fx){

  if (any(is.na(fx)) | any(is.na(y))) {
    stop("\n both 'fx' and 'y' must not contain NA values")
  }
  
  if (length(fx)!=length(y)) {
    stop("both 'fx' and 'y' must be of the same length")
  }

  CT  <- table(y,fx)
  b  <- ncol(CT)
  a  <- nrow(CT)
  q  <- min(c(a,b))
  W  <- length(y)



  C1 <- D1 <- matrix(0,ncol=b,nrow=a)
  if(a>2 && b>2){
    C1 <- funC(CT)
    D1 <- funD(CT)
  }

  C2 <- D2 <- matrix(0,ncol=b,nrow=a)
  if (b>2) {
    C2 <- funC1(CT)
    D2 <- funD1(CT)
  }

  C3 <- D3 <- matrix(0,ncol=b,nrow=a)
  if (a>2) {
    C3 <- funC2(CT)
    D3 <- funD2(CT)
  }
  C <- C1 + C2 + C3
  D <- D1 + D2 + D3

  C[1,1] <- sum(CT[2:a,2:b])
  C[a,b] <- sum(CT[1:(a-1),1:(b-1)])
  C[a,1] <- C[1,b] <- 0

  D[1,b] <- sum(CT[2:a,1:(b-1)])
  D[a,1] <- sum(CT[1:(a-1),2:b])
  D[1,1] <- D[a,b] <- 0

  P  <- sum(CT*C)
  Q  <- sum(CT*D)

  tauC      <- list()
  tauC$val  <- q*(P-Q)/(W^2*(q-1))
  tauC$ASE  <- 2*q/((q-1)*W^2)*sqrt(sum(CT*(C-D)^2)-1/W*(P-Q)^2)
  tauC$ASE0 <- tauC$ASE
  

  return(tauC)
}

#' @title Covariance of two volumes under the ROC surface
#' @description Computes the covariance of the two volumes under the ROC surface (VUS) implied by two predictions \code{fx1} and \code{fx2} (i.e. values of two ranking functions f1 and f2) for a vector of realisations \code{y} (i.e. realised categories) in a multi-class classification problem.
#' @param y a vector of realized categories.
#' @param fx1 a vector of predicted values of the ranking function f1.
#' @param fx2 a vector of predicted values of the ranking function f2.
#' @param ncores number of cores to be used for parallelized computations. Its default value is 1.
#' @param clusterType type of cluster to be initialized in case more than one core is used for calculations. Its default value is "SOCK". For details regarding the different types to be used, see \code{\link[parallel]{makeCluster}}.
#' @return The implemented algorithm is based on Waegeman, De Baets and Boullart (2008). A list of length three is returned, containing the following components:
#' \item{cov}{covariance of the two volumes under the ROC surface implied by f1 and f2}
#' \item{val_f1}{volume under the ROC surface implied by f1}
#' \item{val_f2}{volume under the ROC surface implied by f2}
#' @examples VUScov(c(1,2,1,3,2,3),c(1,2,3,4,5,6),c(1,3,2,4,6,5))
#' @references Waegeman W., De Baets B., Boullart L., 2008. On the scalability of ordered multi-class ROC analysis. Computational Statistics & Data Analysis 52, 3371-3388.

VUScov<-function(y,fx1,fx2,ncores=1,clusterType="SOCK"){

  if (any(is.na(fx1)) | any(is.na(fx2)) | any(is.na(y))) {
    stop("\n no NA values allowed for neither 'fx1', 'fx2' nor 'y'")
  }
  
  if (length(y)!=length(fx1) | length(y)!=length(fx2)) {
  	stop("\n 'fx1', 'fx2' and 'y' need to have the same dimension.")
  }

  dat <- cbind(y,fx1,fx2)
  n   <- length(y)
  u   <- sort(unique(y))
  r   <- length(u)
  uu  <- 1:r
  dat <- cbind(dat,rep(NA,n))

  for (i in 1:n) {
    dat[i,4] <- which(dat[i,1]==u)
  }

  part <- matrix(0, nrow=2^r, ncol=r)
  for (i in 1:r) {
    part[,i] <- kronecker((0:(2^(r-i+1)-1))%%2, matrix(1,nrow=2^(i-1),ncol=1))
  }


  foreachPartition <- function(s,vurocs1,vurocs2,uu,dat,part,r) {
  
    W <- vector(mode="list",length=r)
    for (k in 1:r) {
      Z11 <- uu[as.logical(part[s,])]
      isinK <- dat[,1]==u[k]
      if (sum(uu[k]==Z11)>0) {
        for (i in 1:sum(isinK)) {
          W[[k]] <- c(W[[k]],list(matrix(rep(dat[isinK,,drop=FALSE][i,],2),ncol=4, byrow=TRUE)))
        }
      }
      else {
        for (l in 1:sum(isinK)) {
          for (j in 1:sum(isinK)) {
            W[[k]] <- c(W[[k]],list(matrix(c(dat[isinK,,drop=FALSE][l,],dat[isinK,,drop=FALSE][j,]),ncol=4, byrow=TRUE)))
          }
        }
      }
    }

    len <- integer(r-1)
    for (k in 1:(r-1)) {
      len[k] <- length(W[[k]])*length(W[[k+1]])
    }

    len <- c(0,cumsum(len))
    E <- integer(len[length(len)])
    for (k in 1:(r-1)) {
      out1 <- 0
      for (a in 1:length(W[[k]])) {
        out1 <- out1+1
        out2 <- 0
        for (b in 1:length(W[[k+1]])) {
          out2 <- out2+1
          if (W[[k]][[a]][1,2] < W[[k+1]][[b]][1,2] & W[[k]][[a]][2,3] < W[[k+1]][[b]][2,3]) {
            E[out2+(out1-1)*length(W[[k+1]])+len[k]] <- 1
          }
          else {
            E[out2+(out1-1)*length(W[[k+1]])+len[k]] <- 0
          }
        }
      }
    }

    node <- c(0,cumsum(sapply(W,length)))
    gamma <- integer(node[length(node)])
    gamma[1:length(W[[1]])] <- 1
    for (k in 1:(r-1)) {
      int1 <- 0
      for (a in 1:length(W[[k]])) {
        int1 <- int1 + 1
        int2 <- 0
        for (b in 1:length(W[[k+1]])) {
          int2 <- int2 + 1
          gamma[int2+node[k+1]] <- gamma[int2+node[k+1]]+gamma[int1+node[k]]*E[int2+(int1-1)*length(W[[k+1]])+len[k]]
        }
      }
    }


    ped <- gamma[((length(gamma)-length(W[[r]]))+1):length(gamma)]
    paths <- sum(ped)
    Z2 <- uu[!as.logical(part[s,])]
    n.under <- prod(vurocs1[[2]][Z2])*prod(vurocs1[[2]])
    cov <- prod(vurocs1[[2]][Z2]-1)*(paths/n.under- (vurocs1[[1]]*vurocs2[[1]]))
  }
  vurocs1 <- VUS(y,fx1)
  vurocs2 <- VUS(y,fx2)
  
  if (ncores==1) {
    cov <- sapply(1:2^r,foreachPartition,vurocs1,vurocs2,uu,dat,part,r)
  } else {
    cl <- makeCluster(min(ncores,detectCores()-1), type=clusterType )
    registerDoParallel(cl)
    cov <- foreach(i=1:2^r,.combine = c) %dopar% foreachPartition(i,vurocs1,vurocs2,uu,dat,part,r)
    on.exit(stopCluster(cl))
  }
  
  cov <- sum(cov)/prod(vurocs1$count)
  
  return(list(cov=cov,val_f1=vurocs1[[1]],val_f2=vurocs2[[1]]))
}

#' @title Cumulative LGD Accuracy Ratio
#' @description Calculates for a vector of realized categories \code{y} and a vector of predicted categories \code{hx} the cumulative LGD accuarcy ratio (CLAR) according to Ozdemir and Miu 2009.
#' @param hx a vector of  predicted values.
#' @param y a vector of  realized values.
#' @return The function returns the CLAR for a vector of realized categories \code{y} and a vector of predicted categories \code{hx}.
#' @examples clar(rep(1:5, each = 3), c(3, 3, 3, rep(2:5, each = 3)))
#' @references Ozdemir, B., Miu, P., 2009. Basel II Implementation. A Guide to Developing and Validating a Compliant Internal Risk Rating System. McGraw-Hill, USA.

clar <- function(y, hx) {
    if (any(is.na(hx)) | any(is.na(y))) {
        stop("\n both 'hx' and 'y' must not contain NA values")
    }

    if (length(hx) != length(y)) {
        stop("\n both 'hx' and 'y' must be of the same length")
    }

    nx <- length(hx)
    classes <- sort(union(unique(hx), unique(y)), decreasing = TRUE)
    num <- rep(NA, length(classes))
    for (i in 1:length(classes)) {
        num[i] <- sum(hx == classes[i])
    }
    cnum <- cumsum(num)
    index <- order(hx, decreasing = TRUE)
    hx <- hx[index]
    y <- y[index]
    corr <- rep(0, length(classes))
    for (i in 1:(length(classes) - 1)) {
        if (cnum[i] > 0) corr[i] <- sum(y[1:cnum[i]] >= classes[i])
    }
    corr <- corr / nx
    corr[length(classes)] <- 1
    obs <- cnum / nx

    res <- obs[1] * corr[1] / 2
    for (i in 2:length(corr)) {
        res <- res + (corr[i] - corr[i - 1]) * (obs[i] - obs[i - 1]) / 2 + (obs[i] - obs[i - 1]) * corr[i - 1]
    }
    res * 2
}

#' @title Somers' D and its asymptotic standard errors
#' @description Computes Somers' D on a given cartesian product Y x f(X), where Y consists of the components of \code{y} and f(X) consists of the components of \code{fx}. Furthermore, the asymptotic standard error as well as the modified asymptotic standard error to test the null hypothesis that the measure is zero are provided as defined in Goktas and Oznur (2011).
#' @param y a vector of realized categories.
#' @param fx a vector of predicted values of the ranking function f.
#' @return A list of length three is returned, containing the following components:
#' \item{val}{Somers' D}
#' \item{ASE}{the asymptotic standard error of Somers' D}
#' \item{ASE0}{the modified asymptotic error of Somers' D under the null hypothesis.}
#' @examples SomersD(rep(1:5,each=3),c(3,3,3,rep(2:5,each=3)))
#' @references Goktas, A., Oznur, I., 2011. A Comparison of the Most Commonly Used Measures of Association for Doubly Ordered Square Contingency Tables via Simulation. Metodoloski zvezki 8 (1), 17-37



SomersD <- function(y,fx){

  if (any(is.na(fx)) | any(is.na(y))) {
    stop("\n both 'fx' and 'y' must not contain NA values")
  }
  
  if (length(fx)!=length(y)) {
    stop("\n both 'fx' and 'y' must be of the same length")
  }

  CT  <- table(y,fx)
  b  <- ncol(CT)
  a  <- nrow(CT)
  r  <- rowSums(CT)
  RR <- cumsum(r)+(1-r)/2
  W <- length(y)

  C1 <- D1 <- matrix(0,ncol=b,nrow=a)
  if(a>2 && b>2){
    C1 <- funC(CT)
    D1 <- funD(CT)
  }

  C2 <- D2 <- matrix(0,ncol=b,nrow=a)
  if (b>2) {
    C2 <- funC1(CT)
    D2 <- funD1(CT)
  }

  C3 <- D3 <- matrix(0,ncol=b,nrow=a)
  if (a>2) {
    C3 <- funC2(CT)
    D3 <- funD2(CT)
  }
  C <- C1 + C2 + C3
  D <- D1 + D2 + D3

  C[1,1] <- sum(CT[2:a,2:b])
  C[a,b] <- sum(CT[1:(a-1),1:(b-1)])
  C[a,1] <- C[1,b] <- 0

  D[1,b] <- sum(CT[2:a,1:(b-1)])
  D[a,1] <- sum(CT[1:(a-1),2:b])
  D[1,1] <- D[a,b] <- 0

  P  <- sum(CT*C)
  Q  <- sum(CT*D)
  Dr <- W^2-sum(r^2)

  SomersD      <- list()
  SomersD$val  <- (P-Q)/Dr
  SomersD$ASE0 <- 2/Dr*sqrt(sum(CT*(C-D)^2)-(P-Q)^2/W)
  SomersD$ASE  <- 2/Dr^2*sqrt(sum(CT*(Dr*(C-D)-(P-Q)*(W-matrix(rep(RR,b),byrow=FALSE,ncol=b)))^2))

  return(SomersD)
}

#' @title Adjusted Cumulative LGD Accuracy Ratio
#' @description Calculates for a vector of realized categories \code{y} and a vector of predicted categories \code{hx} the cumulative LGD accuarcy ratio (CLAR) according to Ozdemir and Miu (2009) and adjusts it such that the measure has a value of zero if the two ordinal rankings are in reverse order.
#' @param hx a vector of predicted categories.
#' @param y a vector of realized categories.
#' @return The function returns the adjusted CLAR for a vector of realized categories \code{y} and a vector of predicted categories \code{hx}.
#' @examples clarAdj(rep(1:5,each=3),c(3,3,3,rep(2:5,each=3)))
#' @references Ozdemir, B., Miu, P., 2009. Basel II Implementation. A Guide to Developing and Validating a Compliant Internal Risk Rating System. McGraw-Hill, USA.


clarAdj<-function(y,hx){

  if (any(is.na(hx)) | any(is.na(y))) {
    stop("\n both 'hx' and 'y' must not contain NA values")
  }
  
  if (length(hx)!=length(y)) {
    stop("\n both 'hx' and 'y' must be of the same length")
  }
  
  index=order(hx,decreasing=TRUE)
  hx=hx[index]
  y=y[index]
  adj=clar(y[order(y)],hx)
  (clar(y,hx)-adj)/(1-adj)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify the WPA metrics that have the biggest change between two
#'   periods.
#'
#' @description
#' `r lifecycle::badge('experimental')`
#'
#' This function uses the Information Value algorithm to predict
#' which Workplace Analytics metrics are most explained by the change in dates.
#'
#' @author Mark Powers <mark.powers@@microsoft.com>
#'
#' @param data Person Query as a dataframe including date column named "Date"
#'   This function assumes the data format is `MM/DD/YYYY` as is standard in a
#'   Workplace Analytics query output.
#' @param before_start Start date of "before" time period in `YYYY-MM-DD`.
#'   Defaults to earliest date in dataset.
#' @param before_end End date of "before" time period in `YYYY-MM-DD`
#' @param after_start Start date of "after" time period in `YYYY-MM-DD`.
#'   Defaults to day after before_end.
#' @param after_end End date of "after" time period in `YYYY-MM-DD`. Defaults to
#'   latest date in dataset.
#' @param mybins Number of bins to cut the data into for Information Value
#'   analysis. Defaults to 10.
#' @param return  String specifying what to return. The current only valid
#' option is `"table"`.
#'
#' @return
#' data frame containing all the variables and the corresponding Information
#' Value.
#'
#' @import dplyr
#'
#' @family Variable Association
#' @family Information Value
#' @family Time-series
#'
#' @examples
#' # Returns a data frame
#' sq_data %>%
#'     IV_by_period(
#'         before_start = "2019-11-03",
#'         before_end = "2019-11-09",
#'         after_start = "2019-11-10",
#'         after_end = "2019-11-16"
#'     )
#'
#' @export

IV_by_period <-
    function(data,
             before_start = min(as.Date(data$Date, "%m/%d/%Y")),
             before_end,
             after_start = as.Date(before_end) + 1,
             after_end = max(as.Date(data$Date, "%m/%d/%Y")),
             mybins = 10,
             return = "table") {

        ## Check inputs
        required_variables <- c(
            "Date",
            "PersonId"
        )
        ## Error message if variables are not present
        ## Nothing happens if all present
        data %>%
            check_inputs(requirements = required_variables)

        daterange_1_start <- as.Date(before_start)
        daterange_1_end <- as.Date(before_end)
        daterange_2_start <- as.Date(after_start)
        daterange_2_end <- as.Date(after_end)

        WpA_dataset <- data %>% mutate(Date = as.Date(Date, "%m/%d/%Y"))


        # Check for dates in data file
        if (daterange_1_start < min(WpA_dataset$Date) |
            daterange_1_start > max(WpA_dataset$Date) |
            daterange_1_end < min(WpA_dataset$Date) |
            daterange_1_end > max(WpA_dataset$Date) |
            daterange_2_start < min(WpA_dataset$Date) |
            daterange_2_start > max(WpA_dataset$Date) |
            daterange_2_end < min(WpA_dataset$Date) |
            daterange_2_end > max(WpA_dataset$Date)) {
            stop("Dates not found in dataset")
            geterrmessage()
        }

        # Create variable => Period
        WpA_dataset_table <-
            WpA_dataset %>%
            mutate(
                Period = case_when(
                    Date >= daterange_1_start &
                        Date <= daterange_1_end ~ "Before",
                    Date >= daterange_2_start &
                        Date <= daterange_2_end ~ "After"
                )
            ) %>%
            filter(Period == "Before" | Period == "After")

        WpA_dataset_table <-
            WpA_dataset_table %>% mutate(outcome = case_when(
                Period == "Before" ~ "0",
                Period == "After" ~ "1"
            ))

        # De-select character columns
        train <-
            WpA_dataset_table %>%
            transform(outcome = as.numeric(outcome)) %>%
            select_if(is.numeric)

        # Filter out NAs
        train <- train %>%
            filter(rowSums(is.na(.[, ])) < 1)

        # Rename Outcome Variable
        # train <- transform(train, outcome = as.numeric(outcome))
        train <- rename(train, "Outcome" = "outcome")
        colnames(train)


        # Calculate Odds
        odds <-
            sum(train$Outcome) / (length(train$Outcome) - sum(train$Outcome))
        lnodds <- log(odds)

        # IV Analysis
        # IV <- create_infotables(data = train, y = "Outcome", bins = mybins)
        IV <- map_IV(
            data = train,
            outcome = "Outcome",
            bins = mybins
        )


        # if(return == "detailed"){
        #   # Ranking variables using  IV
        #   wb <- createWorkbook()
        #   addWorksheet(wb, "Ranking")
        #   writeDataTable(wb, "Ranking", x = data.frame(IV$Summary))
        #
        #   # Export Individual Tables
        #   for(i in names(IV$Tables)){
        #     print(i)
        #     addWorksheet(wb, substr(i, start = nchar(i) - 30, stop = nchar(i)))
        #     temp <- IV$Tables[[i]]
        #     temp$ODDS <- exp(temp$WOE + lnodds)
        #     temp$PROB <- (temp$ODDS / (temp$ODDS + 1))
        #     writeDataTable(wb, substr(i, start = nchar(i) - 30, stop = nchar(i)) , x = data.frame(temp))
        #   }
        #
        #   # Save Workbook
        #   saveWorkbook(wb, "Output_IV_v2.xlsx", overwrite = TRUE)
        #
        #   # Plot Graph
        #   pdf("Output_IV_v2.pdf")
        #   plot_infotables(IV, IV$Summary$Variable[], same_scale=TRUE)
        #   dev.off()
        # } else
        if (return == "table") {
            # Store all individual dataframes
            Tables <- c()
            Summary <- data.frame(IV$Summary)
            Tables$Summary <- Summary
            for (i in names(IV$Tables)) {
                temp <- IV$Tables[[i]]
                temp$ODDS <- exp(temp$WOE + lnodds)
                temp$PROB <- (temp$ODDS / (temp$ODDS + 1))
                Tables[[i]] <- create_dt(temp, rounding = 2)
            }

            # Return ranking table
            return(Tables$Summary)
            # print("Access individual metrics via Outputs[[metric_name]], e.g., Outputs[[Workweek_span]]")

            # # Store each variable's plot
            # plots <- c()
            # for (i in names(IV$Tables)) {
            #   plots[[i]] <- plot_infotables(IV, i)
            # }
        } else {
            stop("Please enter a valid input for `return`, either detailed or table.")
        }
    }



# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate a Information Value HTML Report
#'
#' @description
#' The function generates an interactive HTML report using Standard Person Query
#' data as an input. The report contains a full Information Value analysis,  a
#' data exploration technique that helps determine which columns in a data set
#' have predictive power or influence on the value of a specified dependent
#' variable.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param predictors A character vector specifying the columns to be used as
#'   predictors. Defaults to NULL, where all numeric vectors in the data will be
#'   used as predictors.
#' @param outcome A string specifying a binary variable, i.e. can only contain
#'   the values 1 or 0.
#' @param bins Number of bins to use in `Information::create_infotables()`,
#'   defaults to 10.
#' @param max_var Numeric value to represent the maximum number of variables to
#' show on plots.
#' @param path Pass the file path and the desired file name, _excluding the file
#'   extension_. For example, `"IV report"`.
#' @param timestamp Logical vector specifying whether to include a timestamp in
#'   the file name. Defaults to TRUE.
#'
#' @section Creating a report:
#'
#' Below is an example on how to run the report.
#'
#' ```
#' library(dplyr)
#'
#' sq_data %>%
#'   mutate(CH_binary = ifelse(Collaboration_hours > 12, 1, 0)) %>% # Simulate binary variable
#'   IV_report(outcome =  "CH_binary",
#'             predictors = c("Email_hours", "Workweek_span"))
#' ```
#'
#' @family Reports
#' @family Variable Association
#' @family Information Value
#'
#' @inherit generate_report return
#'
#' @export
IV_report <- function(data,
                      predictors = NULL,
                      outcome,
                      bins = 5,
                      max_var = 9,
                      path = "IV report",
                      timestamp = TRUE){

  # Create timestamped path (if applicable) -----------------------------------

  if(timestamp == TRUE){
    newpath <- paste(path, wpa::tstamp())
  } else {
    newpath <- path
  }

  # Return IV object directly -------------------------------------------------

  # Call `calculate_IV()` only once
  IV_obj <-
    data %>%
    create_IV(outcome = outcome,
              predictors = predictors,
              bins = bins,
              return = "IV")

  # IV_names
  IV_names <- names(IV_obj$Tables)

  # List of tables -----------------------------------------------------------

  table_list <-
    IV_names %>%
    purrr::map(function(x){
      IV_obj$Tables[[x]] %>%
         mutate(ODDS = exp(WOE + IV_obj$lnodds),
                PROB = ODDS / (ODDS + 1))
    }) %>%
    purrr::set_names(IV_names)

  # List of ggplot objects ----------------------------------------------------

  plot_list <-
   IV_obj$Summary$Variable %>%
   as.character() %>%
   purrr::map(~plot_WOE(IV = IV_obj, predictor = .))

  # Restrict maximum plots to `max_var` ---------------------------------------

  if(length(plot_list) > max_var){

    plot_list <- plot_list[1:max_var]
    table_list <- table_list[1:max_var]

  }

  table_names <- gsub("_", " ", x = names(table_list))

  # Output list ---------------------------------------------------------------

  output_list <-
    list(
      data %>% check_query(return = "text"),
      data %>% create_IV(outcome = outcome, predictors=predictors, bins= bins),
      data %>% create_IV(outcome = outcome,
                         predictors = predictors,
                         bins = bins,
                         return="summary"),
      read_preamble("blank.md") # Header for WOE Analysis
         ) %>%
    c(plot_list) %>%
    c(list(read_preamble("blank.md"))) %>% # Header for Summary Tables
    c(table_list)  %>%
    purrr::map_if(is.data.frame, create_dt) %>%
    purrr::map_if(is.character, md2html)

  title_list <-
    c("Data Overview",
      "Top Predictors",
      "",
      "WOE Analysis",
      rep("", length(plot_list)),
      "Summary - Predictors",
      table_names)


  n_title <- length(title_list)

  title_levels <-
    c(
      2,
      2,
      4,
      2, # Header for WOE Analysis
      rep(4, length(plot_list)),
      2, # Header for WOE Analysis
      rep(3, length(table_list))
      )

  generate_report(title = "Information Value Report",
                  filename = newpath,
                  outputs = output_list,
                  titles = title_list,
                  subheaders = rep("", n_title),
                  echos = rep(FALSE, n_title),
                  levels = title_levels,
                  theme = "cosmo",
                  preamble = read_preamble("IV_report.md"))

}


# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title
#' Calculate Weight of Evidence (WOE) and Information Value (IV) between a
#' single predictor and a single outcome variable.
#'
#' @description
#' Calculates Weight of Evidence (WOE) and Information Value (IV) between a
#' single predictor and a single outcome variable. This function implements the
#' common Information Value calculations whilst maintaining the minimum reliance
#' on external dependencies. Use `map_IV()` for the equivalent of
#' `Information::create_infotables()`, which performs calculations for multiple
#' predictors and a single outcome variable.
#'
#' @details
#' The approach used mirrors the one used in `Information::create_infotables()`.
#'
#' @param data Data frame containing the data.
#' @param outcome String containing the name of the outcome variable.
#' @param predictor String containing the name of the predictor variable.
#' @param bins Numeric value representing the number of bins to use.
#'
#' @import dplyr
#'
#' @return A data frame is returned as an output.
#'
calculate_IV <- function(data,
                         outcome,
                         predictor,
                         bins){

  pred_var <- data[[predictor]]
  outc_var <- data[[outcome]]

  # Check inputs
  if(sum(is.na(outc_var)) > 0){

    stop(
      glue::glue(
        "dependent variable {outcome} has missing values in the input training data frame"
      )
      )
  }

  # Compute q
  q <- stats::quantile(
    pred_var,
    probs = c(1:(bins - 1) / bins),
    na.rm = TRUE,
    type = 3
    )

  # Compute cuts
  cuts <- unique(q)

  # Compute intervals
  intervals <-
    findInterval(
      pred_var,
      vec = cuts,
      rightmost.closed = FALSE)

  # Compute cut_table
  cut_table <-
    table(
      intervals,
      outc_var) %>%
    as.data.frame.matrix()

  ## get min/max
  cut_table_2 <-
    data.frame(
    var = pred_var,
    intervals
  ) %>%
    group_by(intervals) %>%
    summarise(
      min = min(var, na.rm = TRUE) %>% round(digits = 1),
      max = max(var, na.rm = TRUE) %>% round(digits = 1),
      n = n(),
      .groups = "drop"
    ) %>%
    mutate(!!sym(predictor) :=
    glue::glue("[{round(min, digits = 1)},{round(max, digits = 1)}]")) %>%
    mutate(percentage = n / sum(n)) %>%
    select(!!sym(predictor), intervals, n, percentage)

  # Create variables that are double
  cut_table_1 <- as.numeric(cut_table$`1`)
  cut_table_0 <- as.numeric(cut_table$`0`)

  # Non-events in group
  n_non_event <- cut_table_1 * sum(cut_table_0) # t$y_1*sum_y_0
  n_yes_event <- cut_table_0 * sum(cut_table_1) # t$y_0*sum_y_1

  # Compute WOE

  cut_table_2$WOE <-
    ifelse(
      cut_table$`1` > 0 & cut_table$`0` > 0, # Both positive
      log(n_non_event / n_yes_event), # % of non-events divided by % of events
           0) # Otherwise impute 0

  # Compute IV_weight
  p1 <- cut_table$`1` / sum(cut_table$`1`)
  p0 <- cut_table$`0` / sum(cut_table$`0`)

  cut_table_2$IV_weight <- p1 - p0
  cut_table_2$IV <- cut_table_2$WOE * cut_table_2$IV_weight

  cut_table_2 %>%
    mutate(IV = cumsum(IV)) %>%
    # Maintain consistency with `Information::create_infotables()`
    select(
      !!sym(predictor),
      N = "n",
      Percent = "percentage",
      WOE,
      IV)
}

#' @title
#' Calculate Weight of Evidence (WOE) and Information Value (IV) between
#' multiple predictors and a single outcome variable, returning a list of
#' statistics.
#'
#' @description
#' This is a wrapper around `calculate_IV()` to loop through multiple predictors
#' and calculate their Weight of Evidence (WOE) and Information Value (IV) with
#' respect to an outcome variable.
#'
#' @details
#' The approach used mirrors the one used in `Information::create_infotables()`.
#'
#' @param data Data frame containing the data.
#' @param outcome String containing the name of the outcome variable.
#' @param predictors Character vector containing the names of the predictor
#'   variables. If `NULL` (default) is supplied, all numeric variables in the
#'   data will be used.
#' @param bins Numeric value representing the number of bins to use. Defaults to
#'   10.
#'
#' @import dplyr
#'
#' @return A list of data frames is returned as an output. The first layer of
#' the list contains `Tables` and `Summary`:
#'   -  `Tables` is a list of data frames containing the WOE and cumulative sum
#'   IV for each predictor.
#'   - `Summary` is a single data frame containing the IV for all predictors.
#'
map_IV <- function(data,
                   predictors = NULL,
                   outcome,
                   bins = 10){

  if(is.null(predictors)){

    predictors <-
      data %>%
      select(-!!sym(outcome)) %>%
      select(
        where(is.numeric)
      ) %>%
      names()
  }

  # List of individual tables
  Tables <-
    predictors %>%
    purrr::map(function(pred){

      calculate_IV(
        data = data,
        outcome = outcome,
        predictor = pred,
        bins = bins
      )
    }) %>%
    purrr::set_names(
      nm = purrr::map(
        .,
        function(df){
          names(df)[[1]]
        }
      )
    )

  # Compile Summary Table
  Summary <-
    list("df" = Tables,
         "names" = names(Tables)) %>%
    purrr::pmap(function(df, names){

      IV_final <-
        df %>%
        slice(nrow(df)) %>%
        pull(IV)

      data.frame(
        Variable = names,
        IV = IV_final
      )
    }) %>%
    bind_rows() %>%
    arrange(desc(IV))

  # Reorder and combine list
  c(
    list("Tables" = Tables[Summary$Variable]), # Reordered
    list("Summary" = Summary)
  )
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

funC <- function(F) {
    .Call(`_VUROCS_funC`, F)
}

funC1 <- function(F) {
    .Call(`_VUROCS_funC1`, F)
}

funC2 <- function(F) {
    .Call(`_VUROCS_funC2`, F)
}

funD <- function(F) {
    .Call(`_VUROCS_funD`, F)
}

funD1 <- function(F) {
    .Call(`_VUROCS_funD1`, F)
}

funD2 <- function(F) {
    .Call(`_VUROCS_funD2`, F)
}
